// 对时钟信号使用ip核进行分频倍频和偏移
module clk_wiz(
    (*mark_debug="true"*)input wire sys_clk,  // U18
    (*mark_debug="true"*)input wire sys_rst,  //J15
    (*mark_debug="true"*)output wire clk_100m,
    (*mark_debug="true"*)output wire clk_100m_r,  // 180度
    (*mark_debug="true"*)output wire clk_50m,
    (*mark_debug="true"*)output wire clk_25m
);

wire locked;  // 内部时钟是否稳定
wire rst;

// 如果时钟信号稳定之后, 且sys是高电平, 表示板子已经可以正常使用了
// 其他的例化可以使用该信号 当做是否复位标志
assign global_rst = locked && sys_rst; 



clk_wiz_0 u_clk_wiz_0(
    .clk_in1(sys_clk),
    .reset(!sys_rst),
    .clk_out1(clk_100m),
    .clk_out2(clk_100m_r),
    .clk_out3(clk_50m),
    .clk_out4(clk_25m)
);




endmodule